import { isVue3 as F, h as m, inject as Le, provide as Me, ref as x, defineComponent as ee, getCurrentInstance as $e, computed as d, watch as B, onMounted as qe, onBeforeUnmount as Qe, Vue2 as Ye, unref as Ge } from "vue-demi";
import * as V from "vue";
import { createListenerPropsForwarder as re, pick as k, withDefaultProps as te, partition as Y, isHandlerKey as je, normalizeListenerKeys as xe, useFirstQualifiedElement as Je, mergeProps as $, cloneVNode as ae, isDef as Ce, isComment as Xe, isText as Ze, useListenersEmitter as er } from "@visoning/vue-utility";
import { useManualEffect as rr } from "@visoning/vue-floating-core";
import { FloatingCreatorProps as oe, FloatingCreatorDefaultProps as tr, FloatingCreator as or } from "@visoning/vue-floating-core/components";
import { offset as nr, shift as ar, flip as sr, autoPlacement as lr, arrow as pr } from "@floating-ui/core";
import { useInteractionsContext as ir, useClick as cr, useFocus as ur, useHover as fr } from "@visoning/vue-floating-interactions";
var dr = Object.defineProperty, vr = Object.defineProperties, Pr = Object.getOwnPropertyDescriptors, se = Object.getOwnPropertySymbols, _r = Object.prototype.hasOwnProperty, mr = Object.prototype.propertyIsEnumerable, le = (e, r, t) => r in e ? dr(e, r, { enumerable: !0, configurable: !0, writable: !0, value: t }) : e[r] = t, G = (e, r) => {
  for (var t in r || (r = {}))
    _r.call(r, t) && le(e, t, r[t]);
  if (se)
    for (var t of se(r))
      mr.call(r, t) && le(e, t, r[t]);
  return e;
}, Ee = (e, r) => vr(e, Pr(r));
const Se = re(oe, ["onFloatingDataUpdate"]), Or = Ee(G(G({}, k(oe, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate"
])), Se.props), {
  open: Boolean,
  disabled: Boolean,
  virtualElement: Object,
  appendTo: {},
  autoUpdateOnClosed: Boolean,
  offset: [Number, Object, Function],
  shift: [Boolean, Object],
  flip: [Boolean, Object],
  autoPlacement: [Boolean, Object],
  gpuAcceleration: Boolean,
  destoryedOnClosed: Boolean,
  referenceProps: Object,
  popupProps: Object,
  popupWrapper: Function,
  floatingWrapper: Function,
  zIndex: Number
}), De = Ee(G({}, tr), {
  appendTo: "body",
  shift: !0
}), R = te(Or, De);
var yr = Object.defineProperty, gr = Object.defineProperties, wr = Object.getOwnPropertyDescriptors, K = Object.getOwnPropertySymbols, Fe = Object.prototype.hasOwnProperty, Re = Object.prototype.propertyIsEnumerable, pe = (e, r, t) => r in e ? yr(e, r, { enumerable: !0, configurable: !0, writable: !0, value: t }) : e[r] = t, q = (e, r) => {
  for (var t in r || (r = {}))
    Fe.call(r, t) && pe(e, t, r[t]);
  if (K)
    for (var t of K(r))
      Re.call(r, t) && pe(e, t, r[t]);
  return e;
}, hr = (e, r) => gr(e, wr(r)), br = (e, r) => {
  var t = {};
  for (var a in e)
    Fe.call(e, a) && r.indexOf(a) < 0 && (t[a] = e[a]);
  if (e != null && K)
    for (var a of K(e))
      r.indexOf(a) < 0 && Re.call(e, a) && (t[a] = e[a]);
  return t;
};
function W(e, r, t) {
  if (t = Array.isArray(t) ? t : [t], F)
    return m(e, r.data, r.scopedSlots ? hr(q({}, r.scopedSlots), {
      default: (...P) => {
        var _, I;
        return t.concat((I = (_ = r.scopedSlots) == null ? void 0 : _.default) == null ? void 0 : I.call(_, ...P));
      }
    }) : t);
  const a = r.data, {
    key: C,
    ref: h,
    class: O,
    style: f,
    scopedSlots: b
  } = a, c = br(a, [
    "key",
    "ref",
    "class",
    "style",
    "scopedSlots"
  ]), [v, y] = Y(c, (P, _) => je(_)), { propKeys: g } = r, [A, U] = Y(y, (P, _) => !(g != null && g.includes(_)));
  return m(e, {
    key: C,
    ref: h,
    class: O,
    style: f,
    props: U,
    attrs: A,
    scopedSlots: q(q({}, b), r.scopedSlots),
    on: xe(v)
  }, t);
}
const ne = Symbol("ForwardReferenceInjectionKey"), ie = {}, Ie = () => {
  const e = Le(ne, ie);
  return e === ie ? void 0 : e;
}, ft = () => {
  const e = Ie();
  if (!e)
    throw new Error(`injection "${String(ne)}" not found; please ensure the component is wrapped in a <Provider>`);
  return e;
}, $r = (e) => {
  Me(ne, e);
}, jr = (e) => {
  const r = e || x();
  return $r({
    forwardReference: (t) => r.value = t
  }), r;
};
var xr = Object.defineProperty, Cr = Object.defineProperties, Er = Object.getOwnPropertyDescriptors, H = Object.getOwnPropertySymbols, We = Object.prototype.hasOwnProperty, Te = Object.prototype.propertyIsEnumerable, ce = (e, r, t) => r in e ? xr(e, r, { enumerable: !0, configurable: !0, writable: !0, value: t }) : e[r] = t, ue = (e, r) => {
  for (var t in r || (r = {}))
    We.call(r, t) && ce(e, t, r[t]);
  if (H)
    for (var t of H(r))
      Te.call(r, t) && ce(e, t, r[t]);
  return e;
}, fe = (e, r) => Cr(e, Er(r)), Sr = (e, r) => {
  var t = {};
  for (var a in e)
    We.call(e, a) && r.indexOf(a) < 0 && (t[a] = e[a]);
  if (e != null && H)
    for (var a of H(e))
      r.indexOf(a) < 0 && Te.call(e, a) && (t[a] = e[a]);
  return t;
};
const J = {
  floating: "visoning-floating",
  popup: "visoning-popup",
  textWrapper: "visonimg-popup-text-wrapper"
}, Dr = ee({
  name: "VisoningPopup",
  inheritAttrs: !1,
  props: R,
  setup(e, { slots: r, expose: t }) {
    const a = $e(), C = Je(a, (s) => s.nodeType === 1), h = jr(), O = d(() => C.value || h.value), f = Ie();
    f && B(O, () => f.forwardReference(O.value));
    const b = d(() => e.virtualElement || O.value), c = x(), v = x();
    t({
      updatePosition: () => {
        var s;
        return (s = v.value) == null ? void 0 : s.updatePosition();
      },
      getFloatingData: () => {
        var s;
        return (s = v.value) == null ? void 0 : s.getFloatingData();
      },
      getElements: () => ({
        floating: c.value,
        reference: b.value
      })
    });
    const g = (s, p = {}) => typeof s == "object" ? s : p, A = d(() => {
      const s = [];
      return e.offset && s.push(nr(e.offset)), e.shift && s.push(ar(g(e.shift))), e.flip && s.push(sr(g(e.flip))), e.autoPlacement && s.push(lr(g(e.autoPlacement))), s.concat(e.middleware || []);
    }), U = (s) => {
      var p;
      const { open: l, destoryedOnClosed: o } = e;
      if (!l && o)
        return;
      const n = W("div", {
        data: $(e.popupProps, {
          class: J.popup
        })
      }, (p = r.default) == null ? void 0 : p.call(r, s));
      if (F)
        V.withDirectives(n, [[V.vShow, l, "show"]]);
      else {
        const u = {
          name: "show",
          value: l
        };
        (n.data.directives || (n.data.directives = [])).push(u);
      }
      const { popupWrapper: i } = e;
      return i ? i(n) : n;
    }, P = x(null);
    if (!F) {
      const s = () => {
        const { appendTo: o } = e;
        if (!o)
          return;
        const n = new Ye({
          render() {
            return P.value;
          }
        });
        return n.$mount(), (typeof o == "string" ? document.querySelector(o) : o).appendChild(n.$el), () => {
          var u;
          n.unmount(), (u = n.$el) == null || u.remove();
        };
      }, { clear: p, reset: l } = rr(s);
      B(() => e.appendTo, (o) => o ? l() : p()), qe(l), Qe(p);
    }
    const _ = (s) => e.gpuAcceleration ? {
      position: s.strategy,
      top: 0,
      left: 0,
      transform: `translate3d(${s.x}px, ${s.y}px, 0px)`,
      zIndex: e.zIndex
    } : {
      position: s.strategy,
      top: `${s.y}px`,
      left: `${s.x}px`,
      zIndex: e.zIndex
    }, I = (s, p) => {
      let l = m("div", {
        ref: c,
        class: J.floating,
        style: _(s)
      }, [p]);
      if (e.floatingWrapper && (l = e.floatingWrapper(l)), P.value = null, !e.appendTo)
        return l;
      if (F)
        return m(V.Teleport, {
          to: e.appendTo
        }, {
          default: () => [l]
        });
      P.value = l;
    }, L = (s, p) => {
      const l = r.reference && Fr(r.reference(s));
      if (!l || !l.length)
        return;
      const o = Rr(l[0]), { referenceProps: n } = e;
      if (F)
        return [n ? ae(o, n) : o, p];
      {
        const i = n || {}, {
          class: u,
          style: w
        } = i, j = Sr(i, [
          "class",
          "style"
        ]), [E, S] = Y(j, (at, He) => je(He)), D = ae(o, {
          class: u,
          style: w,
          on: xe(E),
          attrs: S
        });
        return p && (D.children = [p].concat(D.children).filter(Ce)), D;
      }
    }, M = Object.keys(oe);
    return () => {
      const s = e.disabled || !e.open && !e.autoUpdateOnClosed, p = fe(ue({}, Se.forwards), {
        reference: b.value,
        floating: c.value,
        disabled: s,
        placement: e.placement,
        strategy: e.strategy,
        middleware: A.value,
        autoUpdate: e.autoUpdate
      });
      return W(or, {
        data: fe(ue({}, p), {
          ref: v
        }),
        propKeys: M,
        scopedSlots: {
          default: (l) => L(l, I(l, U(l)))
        }
      });
    };
  }
});
function Fr(e) {
  return F ? V.getTransitionRawChildren(e, !1) : e.filter((r) => !Xe(r));
}
function Rr(e) {
  return Ze(e) ? m("span", {
    class: J.textWrapper
  }, [e]) : e;
}
var Ir = Object.defineProperty, Wr = Object.defineProperties, Tr = Object.getOwnPropertyDescriptors, de = Object.getOwnPropertySymbols, Ar = Object.prototype.hasOwnProperty, Nr = Object.prototype.propertyIsEnumerable, ve = (e, r, t) => r in e ? Ir(e, r, { enumerable: !0, configurable: !0, writable: !0, value: t }) : e[r] = t, X = (e, r) => {
  for (var t in r || (r = {}))
    Ar.call(r, t) && ve(e, t, r[t]);
  if (de)
    for (var t of de(r))
      Nr.call(r, t) && ve(e, t, r[t]);
  return e;
}, Ae = (e, r) => Wr(e, Tr(r));
const Ne = re(R, ["onFloatingDataUpdate"]), Ve = k(R, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "open",
  "disabled",
  "virtualElement",
  "appendTo",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "referenceProps",
  "popupProps",
  "popupWrapper",
  "floatingWrapper",
  "zIndex"
]), Vr = Ae(X(X({}, Ve), Ne.props), {
  defaultOpen: Boolean,
  interactions: Array,
  delay: [Number, Object],
  clickDelay: [Number, Object],
  hoverDelay: [Number, Object],
  focusDelay: [Number, Object],
  keepOpenWhenPopupHover: Boolean,
  closeWhenClickOutside: Boolean,
  content: [String, Function],
  title: [String, Function],
  theme: String,
  size: String,
  transitionProps: [String, Object],
  showArrow: Boolean,
  arrow: Function,
  arrowProps: Object,
  popoverProps: R.popupProps,
  contentProps: R.popupProps,
  popoverWrapper: R.popupWrapper,
  "onUpdate:open": Function,
  onOpen: Function,
  onClose: Function
}), ke = "visoning-popover", Ue = Ae(X({}, De), {
  open: void 0,
  interactions: () => ["hover"],
  keepOpenWhenPopupHover: !0,
  closeWhenClickOutside: !0,
  theme: "line",
  size: "meduim",
  transitionProps: ke,
  showArrow: !0
}), T = te(Vr, Ue);
function kr(...e) {
  return d(() => {
    const r = {};
    for (let t = 0; t < e.length; t++) {
      const a = Ge(e[t]);
      r.floating = $(r.floating, a.floating), r.reference = $(r.reference, a.reference);
    }
    return r;
  });
}
var Ur = Object.defineProperty, zr = Object.defineProperties, Br = Object.getOwnPropertyDescriptors, Pe = Object.getOwnPropertySymbols, Kr = Object.prototype.hasOwnProperty, Hr = Object.prototype.propertyIsEnumerable, _e = (e, r, t) => r in e ? Ur(e, r, { enumerable: !0, configurable: !0, writable: !0, value: t }) : e[r] = t, z = (e, r) => {
  for (var t in r || (r = {}))
    Kr.call(r, t) && _e(e, t, r[t]);
  if (Pe)
    for (var t of Pe(r))
      Hr.call(r, t) && _e(e, t, r[t]);
  return e;
}, me = (e, r) => zr(e, Br(r));
const N = {
  popover: "visoning-popover",
  content: "visoning-popover-content",
  title: "visoning-popover-title",
  arrow: "visoning-popover-arrow",
  dark: "theme-dark"
}, Lr = ee({
  name: "VisoningPopover",
  inheritAttrs: !1,
  props: T,
  setup(e, { attrs: r, expose: t, slots: a }) {
    const C = $e(), h = er(C), O = x(!!e.defaultOpen), f = d(() => e.open === void 0 ? O.value : e.open), b = (o, n) => {
      O.value = o, o !== e.open && (h.emit("update:opepn", o, n), o ? h.emit("open", n) : h.emit("close", n));
    }, c = x(), v = d(() => {
      var o;
      return (o = c.value) == null ? void 0 : o.getElements();
    }), y = ir(d(() => {
      var o;
      return (o = v.value) == null ? void 0 : o.reference;
    }), d(() => {
      var o;
      return (o = v.value) == null ? void 0 : o.floating;
    }));
    B(y.open, (o) => {
      b(o, y.interactionInfo.value);
    }), B(f, (o) => {
      y.open.value !== o && y.setOpen(o, {
        type: "component"
      });
    });
    const g = (o) => e.interactions.includes(o), A = kr(fr(y, d(() => {
      var o;
      return {
        disabled: !g("hover"),
        delay: (o = e.hoverDelay) != null ? o : e.delay,
        keepOpenWhenPopupHover: !!e.keepOpenWhenPopupHover
      };
    })), ur(y, d(() => {
      var o;
      return {
        disabled: !g("focus"),
        delay: (o = e.focusDelay) != null ? o : e.delay
      };
    })), cr(y, d(() => {
      var o;
      return {
        disabled: !g("click"),
        delay: (o = e.clickDelay) != null ? o : e.delay,
        closeWhenClickOutside: !!e.closeWhenClickOutside
      };
    })), {
      floating: e.popupProps,
      reference: e.referenceProps
    });
    t({
      updatePosition: () => {
        var o;
        return (o = c.value) == null ? void 0 : o.updatePosition();
      },
      getFloatingData: () => {
        var o;
        return (o = c.value) == null ? void 0 : o.getFloatingData();
      },
      getElements: () => {
        var o;
        const n = (o = c.value) == null ? void 0 : o.getElements();
        return {
          reference: n == null ? void 0 : n.reference,
          floating: n == null ? void 0 : n.floating
        };
      }
    });
    const P = x(), _ = ({
      placement: o,
      middlewareData: n
    }) => {
      var i, u, w, j;
      const E = (u = (i = n.arrow) == null ? void 0 : i.y) != null ? u : 0, S = (j = (w = n.arrow) == null ? void 0 : w.x) != null ? j : 0, D = {
        "--vp-arrow-top": `${E}px`,
        "--vp-arrow-left": `${S}px`
      };
      return o.includes("top") || o.includes("bottom") ? D.left = `${S}px` : D.top = `${E}px`, D;
    }, I = (o) => {
      const n = e.arrow || a.arrow;
      return n ? n(o) : m("div", {
        ref: P,
        class: N.arrow,
        style: _(o)
      });
    }, L = d(() => {
      const o = e.middleware || [];
      return e.showArrow && P.value && o.push(pr({
        element: P.value
      })), o;
    }), M = (o) => {
      const { transitionProps: n, popoverWrapper: i } = e;
      if (n) {
        const u = typeof n == "string" ? { name: n } : z({ name: ke }, n);
        if (F) {
          const w = o;
          o = m(V.Transition, u, {
            default: () => w
          });
        } else
          o = m("transition", {
            props: u
          }, [o]);
      }
      return typeof i == "function" ? i(o) : o;
    }, s = (o) => {
      var n, i, u;
      const w = (n = e.title) != null ? n : a.title, j = (i = e.content) != null ? i : a.content, E = typeof w == "function" ? w() : w, S = typeof j == "function" ? j() : j;
      return W("div", {
        data: $(e.popoverProps, {
          class: [
            N.popover,
            `size-${e.size}`,
            e.theme === "dark" && N.dark
          ],
          "data-placement": o.placement
        })
      }, [
        W("div", {
          data: $(e.contentProps, {
            class: N.content
          })
        }, [
          E && m("div", { class: N.title }, [E]),
          S || ((u = a.default) == null ? void 0 : u.call(a))
        ]),
        e.showArrow && I(o)
      ]);
    }, p = Object.keys(R), l = Object.keys(Ve);
    return () => {
      const { value: o } = A, n = me(z(z({}, k(e, l)), Ne.forwards), {
        open: f.value,
        middleware: L.value,
        popupWrapper: M,
        popupProps: $(o.floating),
        referenceProps: $(r, e.referenceProps, o.reference)
      });
      return W(Dr, {
        data: me(z({}, n), {
          ref: c
        }),
        scopedSlots: {
          reference: a.reference,
          default: s
        },
        propKeys: p
      });
    };
  }
});
var Mr = Object.defineProperty, qr = Object.defineProperties, Qr = Object.getOwnPropertyDescriptors, Oe = Object.getOwnPropertySymbols, Yr = Object.prototype.hasOwnProperty, Gr = Object.prototype.propertyIsEnumerable, ye = (e, r, t) => r in e ? Mr(e, r, { enumerable: !0, configurable: !0, writable: !0, value: t }) : e[r] = t, Z = (e, r) => {
  for (var t in r || (r = {}))
    Yr.call(r, t) && ye(e, t, r[t]);
  if (Oe)
    for (var t of Oe(r))
      Gr.call(r, t) && ye(e, t, r[t]);
  return e;
}, ze = (e, r) => qr(e, Qr(r));
const Be = re(T, ["onFloatingDataUpdate", "onOpen", "onClose", "onUpdate:open"]), Ke = k(T, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "interactions",
  "delay",
  "clickDelay",
  "hoverDelay",
  "focusDelay",
  "keepOpenWhenPopupHover",
  "closeWhenClickOutside",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "size",
  "transitionProps",
  "showArrow",
  "arrow",
  "arrowProps",
  "referenceProps",
  "floatingWrapper",
  "zIndex"
]), Jr = ze(Z(Z({}, Ke), Be.props), {
  content: [String, Function],
  textAlign: String,
  tooltipProps: T.popoverProps,
  tooltipWrapper: T.popoverWrapper
}), Xr = ze(Z({}, Ue), {
  textAlign: "start"
}), Zr = te(Jr, Xr);
var et = Object.defineProperty, rt = Object.defineProperties, tt = Object.getOwnPropertyDescriptors, ge = Object.getOwnPropertySymbols, ot = Object.prototype.hasOwnProperty, nt = Object.prototype.propertyIsEnumerable, we = (e, r, t) => r in e ? et(e, r, { enumerable: !0, configurable: !0, writable: !0, value: t }) : e[r] = t, Q = (e, r) => {
  for (var t in r || (r = {}))
    ot.call(r, t) && we(e, t, r[t]);
  if (ge)
    for (var t of ge(r))
      nt.call(r, t) && we(e, t, r[t]);
  return e;
}, he = (e, r) => rt(e, tt(r));
const be = {
  tooltip: "visoning-tooltip",
  content: "visoning-tooltip-content"
}, dt = ee({
  name: "Tooltip",
  inheritAttrs: !1,
  props: Zr,
  setup(e, { attrs: r, slots: t }) {
    const a = x(), C = () => {
      var f, b;
      const c = (f = e.content) != null ? f : t.content, v = typeof c == "function" ? c() : c;
      return m("div", {
        style: {
          textAlign: e.textAlign
        }
      }, [
        m("span", {
          class: be.content
        }, [Ce(v) ? v : (b = t.default) == null ? void 0 : b.call(t)])
      ]);
    }, h = Object.keys(T), O = Object.keys(Ke);
    return () => {
      const f = he(Q(Q({}, k(e, O)), Be.forwards), {
        theme: "dark",
        interactions: ["hover"],
        referenceProps: $(r, e.reference),
        popoverProps: $(e.tooltipProps, {
          class: be.tooltip
        }),
        popoverWrapper: e.tooltipWrapper
      });
      return W(Lr, {
        data: he(Q({}, f), {
          ref: a
        }),
        scopedSlots: {
          reference: t.reference,
          arrow: t.arrow,
          content: C
        },
        propKeys: h
      });
    };
  }
});
export {
  Lr as Popover,
  Ue as PopoverDefaultProps,
  T as PopoverProps,
  Vr as PopoverPropsType,
  ke as PopoverTransitionName,
  Dr as Popup,
  De as PopupDefaultProps,
  R as PopupProps,
  Or as PopupPropsType,
  dt as Tooltip,
  Xr as TooltipDefaultProps,
  Zr as TooltipProps,
  Jr as TooltipPropsType,
  jr as createReferenceForwardContext,
  $r as providePopupContextValue,
  ft as useReferenceForwardContext,
  Ie as useSafeReferenceForwardContent
};
